from openhltspirent.base import Base
class FrameRate(Base):
	"""Configure the total stream rate.
	The vendor must ensure that the rate configured will be what goes out on the wire for the streams generated by this aggregate.
	i.e., 100% line rate / 10 vendor generated streams = 10% line rate per stream
	"""
	YANG_NAME = 'frame-rate'
	YANG_KEYWORD = 'container'
	YANG_KEY = None
	YANG_PROPERTY_MAP = {"Mode": "mode"}
	YANG_ACTIONS = []

	def __init__(self, parent):
		super(FrameRate, self).__init__(parent)

	@property
	def FixedRate(self):
		"""TBD

		Get an instance of the FixedRate class.

		Returns:
			obj(openhltspirent.sessions.config.devicetraffic.framerate.fixedrate.fixedrate.FixedRate)
		"""
		from openhltspirent.sessions.config.devicetraffic.framerate.fixedrate.fixedrate import FixedRate
		return FixedRate(self)._read()

	@property
	def DecrementRate(self):
		"""TBD

		Get an instance of the DecrementRate class.

		Returns:
			obj(openhltspirent.sessions.config.devicetraffic.framerate.decrementrate.decrementrate.DecrementRate)
		"""
		from openhltspirent.sessions.config.devicetraffic.framerate.decrementrate.decrementrate import DecrementRate
		return DecrementRate(self)._read()

	@property
	def IncrementRate(self):
		"""TBD

		Get an instance of the IncrementRate class.

		Returns:
			obj(openhltspirent.sessions.config.devicetraffic.framerate.incrementrate.incrementrate.IncrementRate)
		"""
		from openhltspirent.sessions.config.devicetraffic.framerate.incrementrate.incrementrate import IncrementRate
		return IncrementRate(self)._read()

	@property
	def Mode(self):
		"""TBD

		Getter Returns:
			FIXED | INCREMENT | DECREMENT | SHUFFLE | LIST

		Setter Allows:
			FIXED | INCREMENT | DECREMENT | SHUFFLE | LIST

		Setter Raises:
			ValueError
			InvalidValueError
		"""
		return self._get_value('mode')

	def update(self, Mode=None):
		"""Update the current instance of the `frame-rate` resource

		Args:
			Mode (enumeration): TBD
		"""
		return self._update(locals())

